#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

header "CA" "Recreate" "@TR<<Recreate Certificate Authority>>"

BASEDIR="/packetprotector"

if [ $FORM_initialize ] ; then
	DH_RUNNING=`ps | grep "openssl dhparam" | grep -v grep`
	echo '<pre>'
	cd /etc/easy-rsa/keys
	if [ -n "$DH_RUNNING" ] ; then
		echo 'Diffie Hellman parameters are currently being generated.'
		echo ''
		echo '$DH_RUNNING'
		echo ''
		echo 'Please check back in 15-30 minutes.'
		echo '' 
	else
		# Backup keys and certs
		cd /etc/easy-rsa
		# load current variables (start with KEY_)
		. ./vars
		d=$KEY_DIR
		mkdir `pwd`/bkup-keys 2> /dev/null
		cp -dpf $d/* `pwd`/bkup-keys/ > /dev/null 2> /dev/null
		cp -pf $d/.* `pwd`/bkup-keys/ > /dev/null 2> /dev/null
		cp -pf /etc/mini_httpd/server.pem /etc/mini_httpd/bkup-server.pem > /dev/null 2> /dev/null
		# End backup

		# Section to change the CA info from the defaults (ie. Charlie and Packetprotector.org, etc.)
		# to your own personal info.

		# Set the new variables, want to take these from the web ui
		COUNTRY=US
		PROVINCE=CA
		CITY=Westchester
		ORG=gopherflats.org
		EMAIL=craigh@pobox.com

		# Edit the vars file
		sed -i "s/KEY_COUNTRY=$KEY_COUNTRY/KEY_COUNTRY=$COUNTRY/" ./vars
		sed -i "s/KEY_PROVINCE=$KEY_PROVINCE/KEY_PROVINCE=$PROVINCE/" ./vars
		sed -i "s/KEY_CITY=$KEY_CITY/KEY_CITY=$CITY/" ./vars
		sed -i "s/KEY_ORG=$KEY_ORG/KEY_ORG=\"$ORG\"/" ./vars
		sed -i "s/KEY_EMAIL=$KEY_EMAIL/KEY_EMAIL=\"$EMAIL\"/" ./vars
		
		#  Edit the one file that doesnt have countryName (openssl.3),
		#  then Use the countryName filelist and change everything else
		sed -i "s/emailAddress.*\= $KEY_EMAIL/emailAddress\t\= $EMAIL/" ./openssl.3

		# Get files with countryName, replace defaults with new variables.
		for i in `grep "countryName.*\= [A-Z][A-Z]" * | cut -d: -f1` ; do
			sed -i "s/countryName.*\= $KEY_COUNTRY/countryName\t\= $COUNTRY/" $i
			sed -i "s/stateOrProvinceName.*\= $KEY_PROVINCE/stateOrProvinceName\t\= $PROVINCE/" $i
			sed -i "s/localityName.*\= $KEY_CITY/localityName\t\= $CITY/" $i
			sed -i "s/0.organizationName.*\= $KEY_ORG/0.organizationName\t\= $ORG/" $i
			sed -i "s/emailAddress.*\= $KEY_EMAIL/emailAddress\t\= $EMAIL/" $i
			# want to get $ORG to lowercase
			LOWERCASE_ORG=`echo $ORG | tr '[A-Z]' '[a-z]'`
			sed -i "s/commonName.*\= local.*/commonName\t\= local.$LOWERCASE_ORG/" $i
			sed -i "s/commonName.*\= radius.*/commonName\t\= radius.$LOWERCASE_ORG/" $i
		done

		# Start recreating
		. ./vars > /dev/null
		./clean-all
		echo $(($RANDOM % 89 + 10)) > keys/serial
		./build-ca-batch
		./build-key-server-batch server
		./build-key-radius-batch radius
		. ./vars > /dev/null
		cp openssl-revoked.cnf openssl-client.cnf
		./build-key-pass-batch examplerevokedcert
		rm openssl-client.cnf
		./revoke-full examplerevokedcert
		echo 'Generating Diffie Hellman parameters.'
		echo ''
		echo 'GET COMFORTABLE, THIS MAY TAKE 15-30 MINUTES!'
		echo ''
		. ./vars > /dev/null
		./build-dh
		cat $d/server.crt $d/server.key > /etc/mini_httpd/server.pem
		echo 'Completed creating CA and Server certificates.'
		echo 'To complete certificate creation, please visit the VPN tab to recreate the roots certificate.'
		echo ''
	fi
	echo '</pre>'
fi		

cd /etc/easy-rsa/keys
if [ -s "dh1024.pem" ] ; then
	echo '******************WARNING**********************<br /><br />'
	echo 'The local CA is already initialized.<br /><br />'
	echo '******************WARNING**********************<br /><br />'
elif [ -n "$DH_RUNNING" ] ; then
        echo 'Diffie Hellman parameters are currently being generated.<br />'
        echo '<pre>$DH_RUNNING</pre><br />'
        echo 'Please check back in 15-30 minutes.<br />'
else
	echo 'CA is not initialized.<br /><br />'
	echo '<form enctype="multipart/form-data" method="post">'
	echo 'Click <input type="submit" name="initialize" value="initialize"> to enable the local certificate authority.<br /><br />'
	echo 'WARNING- it may take 15-30 minutes to generate the Diffie Hellman parameters!<br /><br />'
fi
#echo '******************WARNING**********************<br /><br />'

echo '<form enctype="multipart/form-data" method="post">'
echo '<table>'
echo '<tr><td colspan=2>Enter your information for CA variables: </tr>'
echo '<tr><td>Two-Letter Country Code <td> <input type="text" size="5" name="COUNTRY" value="'$COUNTRY'"></tr>'
echo '<tr><td>Two-Letter State or Province Code <td> <input type="text" size="5" name="PROVINCE" value="'$PROVINCE'"></tr>'
echo '<tr><td>City <td> <input type="text" size="35" name="CITY" value="'$CITY'"></tr>'
echo '<tr><td>Organization <td> <input type="text" size="35" name="ORG" value="'$ORG'"></tr>'
echo '<tr><td>Administrator email address <td> <input type="text" size="35" name="EMAIL" value="'$EMAIL'"></tr>'
echo '</form>'
echo '</table>'
echo '<br />'

echo 'Click the button ONLY if you want to recreate the local CA<br /><br />'
#echo '<form enctype="multipart/form-data" method="post">'
echo 'Click <input type="submit" name="initialize" value="initialize"> to re-create the local certificate authority.<br /><br />'
echo 'WARNING- it may take 15-30 minutes to generate the Diffie Hellman parameters!<br /><br />'

footer ?>
<!--
##WEBIF:name:CA:2:Recreate
-->
